using System;
using System.Drawing;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;

using System.Diagnostics;

namespace BackgroundCreator
{
	/// <summary>
	/// Summary description for ImageHistory.
	/// </summary>
	public class ImageHistory : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ListView listView1;
		private System.Windows.Forms.ColumnHeader columnHeader1;
      private System.Windows.Forms.ColumnHeader columnHeader2;

		System.Collections.SortedList viewedImages;
      
      public ImageHistory(System.Collections.SortedList viewedImages) {
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
         this.viewedImages = viewedImages;

         this.Text = String.Format("Image in history: {0}", viewedImages.Count);

         foreach (DateTime key in viewedImages.Keys) {
            try {
               if (System.IO.File.Exists(viewedImages[key].ToString() ) ) {
               /*
						ImageHistoryPanel ihs = new ImageHistoryPanel(viewedImages[i].ToString());

                  ihs.Location = new Point(0, i * 225);
                  this.Controls.Add(ihs);
					*/
                  FileInfo fi = new FileInfo(viewedImages[key].ToString() );
                  ListViewItem lvi = new ListViewItem(new String[] {fi.Name, key.ToString()} );
                  lvi.Tag = fi;
						listView1.Items.Add(lvi);
					}
            } catch (Exception ex) {
               Trace.WriteLine("EX:" + ex);
            }
         }
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
         this.listView1 = new System.Windows.Forms.ListView();
         this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
         this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
         this.SuspendLayout();
         // 
         // listView1
         // 
         this.listView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                    this.columnHeader1,
                                                                                    this.columnHeader2});
         this.listView1.Dock = System.Windows.Forms.DockStyle.Fill;
         this.listView1.FullRowSelect = true;
         this.listView1.Location = new System.Drawing.Point(0, 0);
         this.listView1.Name = "listView1";
         this.listView1.Size = new System.Drawing.Size(576, 454);
         this.listView1.TabIndex = 0;
         this.listView1.View = System.Windows.Forms.View.Details;
         this.listView1.ItemActivate += new System.EventHandler(this.listView1_ItemActivate);
         this.listView1.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.listView1_ColumnClick);
         // 
         // columnHeader1
         // 
         this.columnHeader1.Text = "FileName";
         this.columnHeader1.Width = 281;
         // 
         // columnHeader2
         // 
         this.columnHeader2.Text = "Date Changed";
         this.columnHeader2.Width = 240;
         // 
         // ImageHistory
         // 
         this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
         this.AutoScroll = true;
         this.ClientSize = new System.Drawing.Size(576, 454);
         this.Controls.Add(this.listView1);
         this.Name = "ImageHistory";
         this.Text = "ImageHistory";
         this.ResumeLayout(false);

      }
		#endregion

      private void listView1_ItemActivate(object sender, System.EventArgs e) {
         FileInfo fi = listView1.FocusedItem.Tag as FileInfo;
         System.Diagnostics.Process.Start(fi.FullName);
      }

      private void listView1_ColumnClick(object sender, System.Windows.Forms.ColumnClickEventArgs e) {
         listView1.Sorting = SortOrder.Ascending;
         listView1.Sort();
      }
	}
}
