using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace BackgroundCreator {
   /// <summary>
   /// Image information used for duplicate tracking
   /// </summary>
   [Serializable]
   public class ImageInformation {
      String _directory;
      public String Directory {
         get { return _directory; }
         set { _directory = value; }
      }

      String _fileName;
      /// <summary>
      /// Filename of image
      /// </summary>
      public String FileName {
         get { return _fileName; }
         set { _fileName = value; }
      }

      long _crc;
      /// <summary>
      /// CRC of image. Currently overloaded to be length...
      /// </summary>
      public long CRC {
         get { return _crc; }
         set { _crc = value; }
      }

      public String FullName {
         get { return System.IO.Path.Combine(_directory, _fileName); }
      }

      public ImageInformation(String FileName) {
         FileInfo fi = new FileInfo(FileName);
         _fileName = fi.Name;
         _directory = fi.Directory.FullName;
         _crc = fi.Length;
      }

      public new String ToString() {
         return FullName;
      }
   }
}
