using System;
using System.Collections.Generic;
using TrayRunnerFramework;

using System.IO;

namespace BackgroundCreator {
   /// <summary>
   /// Summary description for Properties.
   /// </summary>
   [Serializable]
   [SaveProperties]
   public class Properties {
      public Properties() {
         //
         // TODO: Add constructor logic here
         //
      }

      private BackgroundType[] _backgroundTypePerMonitor = new BackgroundType[0];
      /// <summary>
      /// Which image should be displayed on each monitor (None, Random, Specific)
      /// </summary>
      public BackgroundType[] BackgroundTypePerMonitor {
         get { return _backgroundTypePerMonitor; }
         set { _backgroundTypePerMonitor = value; }
      }

      private String[] _specificImagePerMonitor = new String[0];
      /// <summary>
      /// If a specific image is specified on a monitor, what is the path?
      /// </summary>
      public String[] SpecificImagePerMonitor {
         get { return _specificImagePerMonitor; }
         set { _specificImagePerMonitor = value; }
      }

      private String _imageDirectory = null;
      /// <summary>
      /// Path where images are located
      /// </summary>
      public String ImageDirectory {
         get { return _imageDirectory; }
         set { _imageDirectory = value; }
      }

      private bool _changeAtInterval = false;
      /// <summary>
      /// Should the background be changed at a specified interval?
      /// </summary>
      public bool ChangeAtInterval {
         get { return _changeAtInterval; }
         set { _changeAtInterval = value; }
      }

      private int _changeAtIntervalMinutes = 15;
      /// <summary>
      /// What interval should the background be changed at (in minutes)
      /// </summary>
      public int ChangeAtIntervalMinutes {
         get { return _changeAtIntervalMinutes; }
         set { _changeAtIntervalMinutes = value; }
      }

      private bool _scaleImageUp = false;
      /// <summary>
      /// Scale the image up to fill the screen.
      /// </summary>
      public bool ScaleImageUp {
         get { return _scaleImageUp; }
         set { _scaleImageUp = value; }
      }

      private bool _accountForTaskBar = false;
      /// <summary>
      /// Account for the taskbar by scaling the image down on the primary monitor.
      /// </summary>
      public bool AccountForTaskBar {
         get { return _accountForTaskBar; }
         set { _accountForTaskBar = value; }
      }

      private System.Collections.SortedList _viewedImages = new System.Collections.SortedList();
      public System.Collections.SortedList ViewedImages {
         get { return _viewedImages; }
         set { _viewedImages = value; }
      }
   }
}
