// TODO Ability to name/rename profile

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MultiMonitor {
   public partial class AddChangeProfiles : Form {
      private List<MultiMonitorProfile> _profiles;
      
      internal AddChangeProfiles(List<MultiMonitorProfile> Profiles) {
         InitializeComponent();

         _profiles = Profiles;

         foreach (MultiMonitorProfile profile in _profiles) {
            ListViewItem lvi = new ListViewItem(profile.Name);
            lvi.Tag = profile;
            listView1.Items.Add(lvi);
         }
      }

      private void menuAddProfile_Click(object sender, EventArgs e) {
         List<MonitorSettings> monitors = MultiMon.EnumAllMonitors();
         MultiMonitorProfile profile = new MultiMonitorProfile("Test", monitors);

         _profiles.Add(profile);

         ListViewItem lvi = new ListViewItem(profile.Name);
         lvi.Tag = profile;
         listView1.Items.Add(lvi);
         lvi.Selected = true;
      }

      private void menuRemProfile_Click(object sender, EventArgs e) {
         ListViewItem lvi = listView1.SelectedItems[0];
         MultiMonitorProfile profile = lvi.Tag as MultiMonitorProfile;

         _profiles.Remove(profile);

         lvi.Remove();
      }

      private void listView1_SelectedIndexChanged(object sender, EventArgs e) {
         menuRemProfile.Enabled = listView1.SelectedItems.Count > 0;
         menuChangeToProfile.Enabled = listView1.SelectedItems.Count > 0;
      }

      private void menuChangeToProfile_Click(object sender, EventArgs e) {
         ListViewItem lvi = listView1.SelectedItems[0];
         MultiMonitorProfile profile = lvi.Tag as MultiMonitorProfile;

         enableProfile(profile);
      }

      private void listView1_ItemActivate(object sender, EventArgs e) {
         ListViewItem lvi = listView1.SelectedItems[0];
         MultiMonitorProfile profile = lvi.Tag as MultiMonitorProfile;

         enableProfile(profile);
      }

      private void enableProfile(MultiMonitorProfile profile) {
         // Enable all the monitors in the profile
         foreach (MonitorSettings ms in profile.Monitors) {
            MultiMon.EnableDisplay(ms, true);
         }

         // Disable any monitors not defined in the profile
         List<MonitorSettings> monitors = MultiMon.EnumAllMonitors();
         for (int i = 0; i < monitors.Count; i++) {
            bool found = false;
            for (int j = 0; j < profile.Monitors.Count; j++) {
               if (monitors[i].DisplayName == profile.Monitors[j].DisplayName) {
                  found = true;
               }
            }

            if (found == false) {
               MultiMon.EnableDisplay(monitors[i], false);
            }
         }
      }
   }
}