using System;
using System.Collections.Generic;
using System.Text;

namespace MultiMonitor {
   [Serializable]
   class MonitorSettings {
      String _displayName;
      public String DisplayName {
         get { return _displayName; }
      }

      int _frequency;
      public int Frequency {
         get { return _frequency; }
      }

      short _bitsPerPixel;
      public short BitsPerPixel {
         get { return _bitsPerPixel; }
      }

      int _height;
      public int Height {
         get { return _height; }
      }

      int _width;
      public int Width {
         get { return _width; }
      }

      short _x;
      public short X {
         get { return _x; }
      }

      short _y;
      public short Y {
         get { return _y; }
      }

      public bool _isPrimary = false;
      public bool IsPrimary {
         get { return _isPrimary; }
      }

      public MonitorSettings(String displayName, int freq, short bitsPerPixel, int height, int width, short x, short y) {
         _displayName = displayName;
         _frequency = freq;
         _bitsPerPixel = bitsPerPixel;
         _height = height;
         _width = width;
         _x = x;
         _y = y;

         if (_x == 0 && _y == 0) _isPrimary = true;

         int index = _displayName.IndexOf('\0');
         if (index > 0) {
            _displayName = _displayName.Substring(0, index);
         }
      }
   }
}
