using System;
using System.Collections;
using System.Drawing;
using System.IO;
using System.Windows.Forms;
using TrayRunnerFramework;

namespace ShowDesktopIcons {

   [TrayProgram("ShowDesktopIcons", "App.ico")]
   [Serializable]
   /// <summary>
   /// Used to grab various pieces of data from the system for easy interaction.
   /// 
   /// Current grabs a URL from the clipboard, or blog data from the Windows Media Blogging Plugin.
   /// 
   /// </summary>
   public class ShowDesktop : MarshalByRefObject, ITrayProgram {

      DesktopList _list;

      public ShowDesktop() {
         _trayMenu = new TrayMenuItem[]{
                                          new TrayMenuItem("Show Desktop Icons", new EventHandler(showDesktop))
                                       } ;
         _list = new DesktopList();
      }

      private TrayMenuItem[] _trayMenu = new TrayMenuItem[0];
      public TrayMenuItem[] TrayMenu {
         get { return _trayMenu; }
      }

      public void OnShutdown() {
      }
      
      public void showDesktop(Object sender, EventArgs e) {
         _list.ShowDialog();
      }

      public void KeepAlive() {
      }
   }
}