// TODO Cleanup the names in here

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace TrayRunner.ConfigPanes {
   /// <summary>
   /// Summary description for PluginDirectoriesForm.
   /// </summary>
   public class PluginDirectoriesForm : System.Windows.Forms.UserControl {
      private System.Windows.Forms.ListView listView1;
      private System.Windows.Forms.Button removeButton;
      private System.Windows.Forms.Button addButton;
      private System.Windows.Forms.ImageList imageList1;
      private System.ComponentModel.IContainer components;

      private ArrayList _pluginDirectories;
      public ArrayList PluginDirectories {
         get { return _pluginDirectories; }
         set { 
            _pluginDirectories = value; 
            if (value == null) return;
            foreach (String key in _pluginDirectories) {
               listView1.Items.Add(new ListViewItem(key));
            }
         }
      }

      internal NewPluginDirectoryEventHandler NewPluginDirectory;
      
      public PluginDirectoriesForm() {
         // This call is required by the Windows.Forms Form Designer.
         InitializeComponent();
      }

      /// <summary> 
      /// Clean up any resources being used.
      /// </summary>
      protected override void Dispose( bool disposing ) {
         if( disposing ) {
            if(components != null) {
               components.Dispose();
            }
         }
         base.Dispose( disposing );
      }

      #region Component Designer generated code
      /// <summary> 
      /// Required method for Designer support - do not modify 
      /// the contents of this method with the code editor.
      /// </summary>
      private void InitializeComponent() {
         this.components = new System.ComponentModel.Container();
         System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(PluginDirectoriesForm));
         this.listView1 = new System.Windows.Forms.ListView();
         this.removeButton = new System.Windows.Forms.Button();
         this.imageList1 = new System.Windows.Forms.ImageList(this.components);
         this.addButton = new System.Windows.Forms.Button();
         this.SuspendLayout();
         // 
         // listView1
         // 
         this.listView1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
         this.listView1.Location = new System.Drawing.Point(8, 8);
         this.listView1.MultiSelect = false;
         this.listView1.Name = "listView1";
         this.listView1.Size = new System.Drawing.Size(200, 232);
         this.listView1.TabIndex = 0;
         this.listView1.View = System.Windows.Forms.View.List;
         this.listView1.SelectedIndexChanged += new System.EventHandler(this.listView1_SelectedIndexChanged);
         // 
         // removeButton
         // 
         this.removeButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
         this.removeButton.Enabled = false;
         this.removeButton.ImageIndex = 1;
         this.removeButton.ImageList = this.imageList1;
         this.removeButton.Location = new System.Drawing.Point(216, 40);
         this.removeButton.Name = "removeButton";
         this.removeButton.Size = new System.Drawing.Size(24, 23);
         this.removeButton.TabIndex = 1;
         this.removeButton.Text = "-";
         this.removeButton.Click += new System.EventHandler(this.removeButton_Click);
         // 
         // imageList1
         // 
         this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
         this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
         this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
         // 
         // addButton
         // 
         this.addButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
         this.addButton.ImageIndex = 0;
         this.addButton.ImageList = this.imageList1;
         this.addButton.Location = new System.Drawing.Point(216, 8);
         this.addButton.Name = "addButton";
         this.addButton.Size = new System.Drawing.Size(24, 23);
         this.addButton.TabIndex = 2;
         this.addButton.Text = "+";
         this.addButton.Click += new System.EventHandler(this.addButton_Click);
         // 
         // PluginDirectoriesForm
         // 
         this.Controls.Add(this.addButton);
         this.Controls.Add(this.removeButton);
         this.Controls.Add(this.listView1);
         this.Name = "PluginDirectoriesForm";
         this.Size = new System.Drawing.Size(248, 248);
         this.ResumeLayout(false);

      }
      #endregion

      private void removeButton_Click(object sender, System.EventArgs e) {
         String path = listView1.SelectedItems[0].Text;
         _pluginDirectories.Remove(path);

         listView1.Items.Remove(listView1.SelectedItems[0]);
      }

      private void addButton_Click(object sender, System.EventArgs e) {
         FolderBrowserDialog fbd = new FolderBrowserDialog();
         // SPECIAL FOLDER WORKING
         fbd.RootFolder = System.Environment.SpecialFolder.MyComputer;
         fbd.ShowNewFolderButton = false;
         if (fbd.ShowDialog() == DialogResult.OK) {
            String path = fbd.SelectedPath.ToLower();

            foreach (String key in _pluginDirectories) {
               if (key.ToLower() == path) {
                  MessageBox.Show("Directory already selected");
                  return;
               }
            }

            // No duplicate found
            // TODO Load any new plugins?
            listView1.Items.Add(new ListViewItem(fbd.SelectedPath));
            _pluginDirectories.Add(fbd.SelectedPath);

            if (NewPluginDirectory != null) {
               NewPluginDirectory(this, new NewPluginDirectoryEventArgs(fbd.SelectedPath));
            }
         }
      }

      private void listView1_SelectedIndexChanged(object sender, System.EventArgs e) {
         removeButton.Enabled = (listView1.SelectedIndices.Count != 0);
      }
   }
}
