using System;
using System.Collections;
using System.ComponentModel;
using System.Configuration.Install;

using System.IO;
using System.Collections.Specialized;
using System.Diagnostics;

namespace TrayRunner {
   /// <summary>
   /// Summary description for Installer1.
   /// </summary>
   [RunInstaller(true)]
   public class Installer1 : System.Configuration.Install.Installer {
      /// <summary>
      /// Required designer variable.
      /// </summary>
      private System.ComponentModel.Container components = null;

      public Installer1() {
         // This call is required by the Designer.
         InitializeComponent();
      }

      protected override void OnAfterInstall(IDictionary savedState) {
         base.OnAfterInstall (savedState);

         // This is obnoxious, but it's an easy way to overwrite the default config
         FileInfo fi = new FileInfo(Context.Parameters["assemblypath"] + ".config");
         DirectoryInfo pluginDi = new DirectoryInfo(Path.Combine(fi.Directory.FullName, "plugins"));
         
         /*
         Trace.WriteLine("Plugin Dir:" + pluginDi.FullName);
         System.IO.StreamWriter sw = new StreamWriter(fi.FullName, false);
         sw.WriteLine(String.Format(@"
<configuration>
 <configSections>
   <section name=""AppDomains"" type=""ConfigReaders.NestedNameValueCollectionSectionHandler, ConfigReaders"" />
   <section name=""HotKeys"" type=""System.Configuration.NameValueSectionHandler"" />
 </configSections>
 <AppDomains />
 <HotKeys />
   <appSettings>
      <add key=""pluginDirs"" value=""{0}"" />
   </appSettings>
</configuration>
", pluginDi.FullName));
         sw.Close();
         */
         ProcessStartInfo psi = new ProcessStartInfo(Context.Parameters["assemblypath"],
            String.Format("-addplugindir \"{0}\"", pluginDi.FullName));
         Process p = Process.Start(psi);
      }

      protected override void OnBeforeUninstall(IDictionary savedState) {
         base.OnBeforeUninstall(savedState);

         FileInfo fi = new FileInfo(Context.Parameters["assemblypath"]);
         if (Process.GetProcessesByName("TrayRunner").Length > 0) {
            System.Windows.Forms.MessageBox.Show("Please shut down any running instances of TrayRunner before uninstalling");
            return;
         }
      }

      /// <summary> 
      /// Clean up any resources being used.
      /// </summary>
      protected override void Dispose( bool disposing ) {
         if( disposing ) {
            if(components != null) {
               components.Dispose();
            }
         }
         base.Dispose( disposing );
      }


      #region Component Designer generated code
      /// <summary>
      /// Required method for Designer support - do not modify
      /// the contents of this method with the code editor.
      /// </summary>
      private void InitializeComponent() {
         components = new System.ComponentModel.Container();
      }
      #endregion
   }
}
