using System;

namespace TrayRunner {
   /// <summary>
   /// EventHandler for NewPlugin event.
   /// </summary>
   public delegate void NewPluginEventHandler(Object sender, NewPluginEventArgs e);

   public class NewPluginEventArgs {
      private String _pluginLocation;
      /// <summary>
      /// Location of the new plugin. This directory will be probed for an exe.
      /// </summary>
      public String PluginLocation {
         get { return _pluginLocation; }
      }

      private String _className;
      /// <summary>
      /// Name of the plugin based on the name of the class in which the 
      /// </summary>
      public String ClassName {
         get { return _className; }
      }

      public NewPluginEventArgs(String pluginLocation, String className) {
         _className = className;
         _pluginLocation = pluginLocation;
      }
   }
}