using System;

namespace TrayRunner {
   /// <summary>
   /// Infomrmation about the key pressed.
   /// </summary>
   public class WhichHotKey {
      private System.Windows.Forms.Keys _key;
      public System.Windows.Forms.Keys Key {
         get { return _key; }
      }

      private bool _windowsKey;
      public bool WindowsKey {
         get { return _windowsKey; }
      }

      public WhichHotKey(System.Windows.Forms.Keys key, bool windowsKey) {
         _key = key;
         _windowsKey = windowsKey;
      }

      public WhichHotKey(String hotKey) {
         if (hotKey.IndexOf("Windows") != -1) {
            _windowsKey = true;
         } else {
            _windowsKey = false;
         }
         int plus = hotKey.LastIndexOf("+");
         String key = hotKey.Substring(plus + 2);

         _key = (System.Windows.Forms.Keys)Enum.Parse(typeof(System.Windows.Forms.Keys), key);
      }

      public override string ToString() {
         if (_windowsKey) {
            return String.Format("Windows + {0}", _key);
         } else {
            return String.Format("Ctrl + Atrl + {0}", _key);
         }
      }

      public override bool Equals(object obj) {
         if (obj is int) {
            return ((int)obj == this.GetHashCode() );
         } else if (obj is WhichHotKey) {
            return (obj.GetHashCode() == this.GetHashCode());
         } else {
            return base.Equals (obj);
         }
      }

      public override int GetHashCode() {
         long hash = (int)_key;
         hash <<= 16;
         if (_windowsKey) {
            hash += 8;
         } else {
            hash += 3;
         }
         return (int)hash;
      }
   }
}
