using System;
using System.Reflection;

namespace TrayRunnerFramework {
	/// <summary>
	/// SerializationBinder that simply pulls the type from the current version of the assembly, regardless
	/// of the Assembly version or FullName
	/// </summary>
	public class Binder : System.Runtime.Serialization.SerializationBinder {
		public Binder() {
		}

		public override Type BindToType(String assemblyName, String typeName) {
			String n = assemblyName.Substring(0, assemblyName.IndexOf(","));
			Assembly assm = Assembly.Load(n);
			Type t = assm.GetType(typeName);

			return t;
		}
	}
}
