using System;
using System.Reflection;
using System.Runtime.Serialization;

namespace TrayRunnerFramework {
   /// <summary>
   /// Summary description for ActualSurrogate.
   /// </summary>
   public class SerializationSurrogate : ISerializationSurrogate {
	
      public SerializationSurrogate() {
         //
         // TODO: Add constructor logic here
         //
      }

      public void GetObjectData(Object obj, SerializationInfo info, StreamingContext context) {
         FieldInfo[] fields = obj.GetType().GetFields(BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance);
         foreach (FieldInfo fi in fields) {
            if (!fi.IsNotSerialized) {
               info.AddValue(fi.Name, fi.GetValue(obj));
            }
         }
      }

      // Used on deserialization
      public Object SetObjectData(Object obj, SerializationInfo info, StreamingContext context, ISurrogateSelector selector) {
         if (info != null) {
            foreach (SerializationEntry key in info ) {
               FieldInfo fi = obj.GetType().GetField(key.Name, BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance);
               if (fi != null && !fi.IsNotSerialized && key.Value != null && key.ObjectType == fi.FieldType) {
                  fi.SetValue(obj, key.Value);
               }
            }
         }

         return obj;
      }
   }
}
